package com.ejie.ab39a.control;

import com.ejie.ab39a.service.EntidadesService;
import com.ejie.ab39a.service.ProvinciaService;
import com.ejie.ab39a.service.TecnicosEntidadService;
import com.ejie.ab39a.validations.TecnicosEntidadValidator;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.ab39a.constantes.Constantes;
import com.ejie.ab39a.exceptions.ErrorField;
import com.ejie.ab39a.exceptions.ErrorGenericoException;
import com.ejie.ab39a.model.Entidades;
import com.ejie.ab39a.model.Provincia;
import com.ejie.ab39a.model.TecnicosEntidad;

/**
 * TecnicosEntidadController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/tecnicosentidad")

public class TecnicosEntidadController {

    private static final Logger logger = LoggerFactory.getLogger(TecnicosEntidadController.class);

    @Autowired
    private TecnicosEntidadService tecnicosEntidadService;

    @Autowired
    private EntidadesService entidadesService;

    @Autowired
    private ProvinciaService provinciaService;

    @Autowired
    private TecnicosEntidadValidator tecnicosEntidadValidation;

    /*
     * OPERACIONES CRUD (Create, Read, Update, Delete)
     * 
     */

    /**
     * Operacion CRUD Read. Devuelve el bean correspondiente al identificador indicado.
     * 
     * @param codtecnico
     *            Integer codtecnico
     * @return TecnicosEntidad Objeto correspondiente al identificador indicado.
     */
    @RequestMapping(value = { "/{codtecnico}", "/get/{codtecnico}" }, method = RequestMethod.GET)
    public @ResponseBody TecnicosEntidad get(@PathVariable Integer codtecnico) {
        TecnicosEntidad tecnicosEntidad = new TecnicosEntidad();
        tecnicosEntidad.setCodtecnico(codtecnico);
        tecnicosEntidad = this.tecnicosEntidadService.find(tecnicosEntidad);
        TecnicosEntidadController.logger.info("[GET - findBy_PK] : Obtener TecnicosEntidad por PK");
        return tecnicosEntidad;
    }

    /**
     * Devuelve una lista de beans correspondientes a los valores de filtrados indicados en el
     * objeto pasado como parametro.
     *
     * @param filterTecnicosEntidad
     *            TecnicosEntidad Objeto que contiene los parametros de filtrado utilizados en la
     *            busqueda.
     * @return List<TecnicosEntidad> Lista de objetos correspondientes a la busqueda realizada.
     */
    @RequestMapping(method = RequestMethod.GET)
    public @ResponseBody List<TecnicosEntidad> getAll(@ModelAttribute TecnicosEntidad filterTecnicosEntidad) {
        TecnicosEntidadController.logger.info("[GET - find_ALL] : Obtener TecnicosEntidad por filtro");
        return this.tecnicosEntidadService.findAll(filterTecnicosEntidad, null);
    }

    /**
     * Operacion CRUD Edit. Modificacion del bean indicado.
     *
     * @param tecnicosEntidad
     *            TecnicosEntidad Bean que contiene la informacion a modificar.
     * @return TecnicosEntidad Bean resultante de la modificacion.
     */
    @RequestMapping(method = RequestMethod.PUT)
    public @ResponseBody TecnicosEntidad edit(@RequestBody TecnicosEntidad tecnicosEntidad) {

        // Validate
        List<ErrorField> errores = this.tecnicosEntidadValidation.validate(tecnicosEntidad);
        if (!errores.isEmpty()) {
            throw new ErrorGenericoException(errores);
        }

        TecnicosEntidad tecnicosEntidadAux = this.tecnicosEntidadService.update(tecnicosEntidad);
        TecnicosEntidadController.logger.info("[PUT] : TecnicosEntidad actualizado correctamente");
        return tecnicosEntidadAux;
    }

    /**
     * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean indicado.
     *
     * @param tecnicosEntidad
     *            TecnicosEntidad Bean que contiene la informacion con la que se va a crear el nuevo
     *            registro.
     * @return TecnicosEntidad Bean resultante del proceso de creacion.
     */
    @RequestMapping(method = RequestMethod.POST)
    public @ResponseBody TecnicosEntidad add(@RequestBody TecnicosEntidad tecnicosEntidad) {
        // Validate
        // List<ErrorField> errores = this.tecnicosEntidadValidation.validate(tecnicosEntidad);
        // Validamos que el dni/nif no exista ya en BBDD
        TecnicosEntidad tecnicosEntidadFilter = new TecnicosEntidad();
        tecnicosEntidadFilter.setDocidentificacion(tecnicosEntidad.getDocidentificacion());
        List<TecnicosEntidad> lista = this.tecnicosEntidadService.findAll(tecnicosEntidadFilter, null);
        // if (lista != null && !lista.isEmpty()) {
        // errores.add(new ErrorField("validacion.existeDNI"));
        // }
        //
        // if (!errores.isEmpty()) {
        // throw new ErrorGenericoException(errores);
        // }

        TecnicosEntidad tecnicosEntidadAux = this.tecnicosEntidadService.add(tecnicosEntidad);
        TecnicosEntidadController.logger.info("[POST] : TecnicosEntidad insertado correctamente");
        return tecnicosEntidadAux;
    }

    /**
     * Operacion CRUD Delete. Borrado del registro correspondiente al identificador especificado.
     *
     * @param codtecnico
     *            Integer Identificador del objeto que se desea eliminar.
     * @param codentidad
     *            Integer codentidad
     * @return TecnicosEntidad Bean eliminado.
     */
    @RequestMapping(value = "/borrarEntidad/{codtecnico}/{codentidad}", method = RequestMethod.DELETE)
    @ResponseStatus(value = HttpStatus.OK)
    public @ResponseBody TecnicosEntidad borrarEntidadTecnico(@PathVariable Integer codtecnico,
            @PathVariable Integer codentidad) {
        TecnicosEntidad tecnicosEntidad = new TecnicosEntidad();
        this.tecnicosEntidadService.borrarEntidadTecnico(codtecnico, codentidad);
        TecnicosEntidadController.logger.info("[DELETE] : TecnicosEntidad borrado correctamente");
        return tecnicosEntidad;
    }

    /**
     * Operacion CRUD Delete. Borrado del registro correspondiente al identificador especificado.
     *
     * @param tecnicosEntidad
     *            TecnicosEntidad Identificador del objeto que se desea eliminar.
     * @return TecnicosEntidad Bean eliminado.
     */
    @RequestMapping(value = "/remove", method = RequestMethod.POST)
    @ResponseStatus(value = HttpStatus.OK)
    public @ResponseBody TecnicosEntidad remove(@RequestBody TecnicosEntidad tecnicosEntidad) {
        this.tecnicosEntidadService.remove(tecnicosEntidad);
        TecnicosEntidadController.logger.info("[DELETE] : TecnicosEntidad activar/desactivar correctamente");
        return tecnicosEntidad;
    }

    /**
     * desactivar el tecnico
     * 
     * @param codtecnico
     *            Integer codtecnico
     * @return TecnicosEntidad TecnicosEntidad
     */
    @RequestMapping(value = "/{codtecnico}", method = RequestMethod.POST)
    @ResponseStatus(value = HttpStatus.OK)
    public @ResponseBody TecnicosEntidad desactivar(@PathVariable Integer codtecnico) {
        TecnicosEntidad tecnicosEntidad = new TecnicosEntidad();
        tecnicosEntidad.setCodtecnico(codtecnico);
        this.tecnicosEntidadService.remove(tecnicosEntidad);
        TecnicosEntidadController.logger.info("[DELETE] : TecnicosEntidad borrado correctamente");
        return tecnicosEntidad;
    }

    /*
     * METODOS COMPONENTE RUP_TABLE
     * 
     */

    /**
     * Metodo de presentacion del RUP_TABLE.
     * 
     * @param model
     *            Model model
     * @return String String
     */
    @RequestMapping(value = "/maint", method = RequestMethod.GET)
    public String getFormEdit(Model model) {
        TecnicosEntidadController.logger.info("[GET - View] : tecnicosentidad");

        Provincia provincia = new Provincia();
        provincia.setIdAutonomia(Constantes.COD_EUSKADI);
        model.addAttribute("comboTH",
                this.provinciaService.findAll(provincia, new JQGridRequestDto(null, null, "IDPROVINCIA", "ASC")));

        return "tecnicosentidad";
    }

    /**
     * Operacion de filtrado del componente RUP_TABLE.
     * 
     * @param filterTecnicosEntidad
     *            TecnicosEntidad Bean que contiene los parametros de filtrado a emplear.
     * @param jqGridRequestDto
     *            Dto que contiene los parametros de configuracion propios del RUP_TABLE a aplicar
     *            en el filtrado.
     * @return JQGridResponseDto<TecnicosEntidad> Dto que contiene el resultado del filtrado
     *         realizado por el componente RUP_TABLE.
     */
    @RequestMapping(value = "/filter", method = RequestMethod.POST)
    public @ResponseBody JQGridResponseDto<TecnicosEntidad> filter(
            @RequestJsonBody(param = "filter") TecnicosEntidad filterTecnicosEntidad,
            @RequestJsonBody JQGridRequestDto jqGridRequestDto) {
        TecnicosEntidadController.logger.info("[POST - filter] : Obtener TecnicosEntidads");
        return this.tecnicosEntidadService.filter(filterTecnicosEntidad, jqGridRequestDto, false);
    }

    /**
     * Operacion de filtrado del componente RUP_TABLE.
     * 
     * @param filterEntidades
     *            Entidades Bean que contiene los parametros de filtrado a emplear.
     * @param jqGridRequestDto
     *            Dto que contiene los parametros de configuracion propios del RUP_TABLE a aplicar
     *            en el filtrado.
     * @param codtecnico
     *            Integer codtecnico
     * @return JQGridResponseDto<Entidades> Dto que contiene el resultado del filtrado realizado por
     *         el componente RUP_TABLE.
     */
    @RequestMapping(value = "/entidades/{codtecnico}/filter", method = RequestMethod.POST)
    public @ResponseBody JQGridResponseDto<Entidades> filter(
            @RequestJsonBody(param = "filter") Entidades filterEntidades,
            @RequestJsonBody JQGridRequestDto jqGridRequestDto, @PathVariable Integer codtecnico) {
        TecnicosEntidadController.logger.info("[POST - filter] : Obtener Entidadess");

        TecnicosEntidad tecnicosEntidad = new TecnicosEntidad();
        tecnicosEntidad.setCodtecnico(codtecnico);
        filterEntidades.setTecnicosEntidad(tecnicosEntidad);

        return this.entidadesService.filter(filterEntidades, jqGridRequestDto, false);
    }

    /**
     * Borrado multiple de registros
     * 
     * @param filterTecnicosEntidad
     *            TecnicosEntidad Bean que contiene los parametros de filtrado a emplear.
     * @param jqGridRequestDto
     *            Dto que contiene los parametros de configuracion propios del RUP_TABLE a aplicar
     *            en la busqueda.
     * @return List<String> Lista de los identificadores de los registros eliminados.
     * 
     */
    @RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
    @ResponseStatus(value = HttpStatus.OK)
    public @ResponseBody List<String> removeMultiple(
            @RequestJsonBody(param = "filter") TecnicosEntidad filterTecnicosEntidad,
            @RequestJsonBody JQGridRequestDto jqGridRequestDto) {
        TecnicosEntidadController.logger
                .info("[POST - search] : [POST - removeMultiple] : Eliminar multiples TecnicosEntidads");
        this.tecnicosEntidadService.removeMultiple(filterTecnicosEntidad, jqGridRequestDto, false);
        TecnicosEntidadController.logger.info("All entities correctly deleted!");

        return jqGridRequestDto.getMultiselection().getSelectedIds();
    }

    /**
     * guarda las entidades
     * 
     * @param codtecnico
     *            Integer codtecnico
     * @param codentidades
     *            List<String> codentidades
     * @return TecnicosEntidad TecnicosEntidad
     */
    @RequestMapping(value = { "/guardarEntidades/{codtecnico}" }, method = RequestMethod.POST)
    public @ResponseBody TecnicosEntidad guardarEntidades(@PathVariable Integer codtecnico,
            @RequestBody List<String> codentidades) {
        TecnicosEntidad tecnicosEntidadAux;
        TecnicosEntidad tecnicosEntidad = new TecnicosEntidad();
        tecnicosEntidad.setCodtecnico(codtecnico);

        List<Entidades> listaEntidades = new ArrayList<Entidades>();
        Entidades entidad;
        for (String codEntidad : codentidades) {
            entidad = new Entidades();
            entidad.setCodentidad(new Integer(codEntidad));
            listaEntidades.add(entidad);
        }

        tecnicosEntidad.setEntidadeses(listaEntidades);

        tecnicosEntidadAux = this.tecnicosEntidadService.guardarEntidadesTecnico(tecnicosEntidad);
        TecnicosEntidadController.logger.info("[PUT] : TecnicosEntidad actualizado correctamente");

        TecnicosEntidadController.logger
                .info("[POST - guardarEntidades] :Guardar Entidades relacionadas con el técnico");
        return tecnicosEntidadAux;
    }

    /**
     * Creacion de un nuevo registro a partir del bean indicado en la tabla tecnicos_entidad. e
     * inserta un registro de relacion con la entidad que lo está dando de alta entidad_tecnico
     *
     * @param tecnicosEntidad
     *            TecnicosEntidad Bean que contiene la informacion con la que se va a crear el nuevo
     *            registro.
     * @param codentidad
     *            Integer codentidad
     * @return TecnicosEntidad Bean resultante del proceso de creacion.
     */
    @RequestMapping(value = { "/guardarTecnicoEntidades/{codentidad}" }, method = RequestMethod.POST)
    public @ResponseBody TecnicosEntidad addTecnicoEntidad(@RequestBody TecnicosEntidad tecnicosEntidad,
            @PathVariable Integer codentidad) {

        TecnicosEntidadController.logger.info("[POST] : TecnicosEntidad guardarTecnicoEntidades INICIO");

        List<Entidades> listaEntidades = new ArrayList<Entidades>();
        Entidades entidad = new Entidades();

        entidad.setCodentidad(codentidad);

        listaEntidades.add(entidad);

        tecnicosEntidad.setEntidadeses(listaEntidades);

        TecnicosEntidad tecnicosEntidadAux = this.tecnicosEntidadService.addTecnicoRelacion(tecnicosEntidad);

        TecnicosEntidadController.logger.info("[POST] : TecnicosEntidad guardarTecnicoEntidades FIN");

        return tecnicosEntidadAux;
    }
}
